package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.lzmispt.data.center.entity.dto.resource.metadata.EntityItemInfoSearchDTO;
import com.lzmispt.data.center.entity.vo.resource.metadata.EntityChildRelationsItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.InfoItemVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataEntityRelationsVO;
import com.lzmispt.data.resource.dao.metadata.IMetadataDao;
import com.lzmispt.data.resource.dao.resources.IResourcesDao;
import com.lzmispt.data.resource.entity.dto.metadata.EditEntityRelationsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.GetRelationsDataDTO;
import com.lzmispt.data.resource.entity.dto.metadata.MetaEntityRelationsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.UpdateEntityRelationsDTO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityRelationsPO;
import com.lzmispt.data.resource.entity.po.resources.ResEntityRelationsPO;
import com.lzmispt.data.resource.entity.vo.metadata.MetaEntityRelationsVO;
import com.lzmispt.data.resource.entity.vo.metadata.UseEntityRelationInfoVO;
import com.lzmispt.data.resource.service.metadata.IEntityRelation;
import com.lzmispt.data.resource.service.metadata.IInfoItem;
import com.lzmispt.data.resource.service.metadata.IResAndDataEntityRelation;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

@Service
public class IResAndDataEntityRelationImpl implements IResAndDataEntityRelation {
  public ResultEntity<List> getRelationsMapByDirectoryIdForMetadata(Long directoryId, String platCode, String tokenId) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationsMapByDirectoryId(directoryId, DCConst.DataResourceCategory.DATA, platCode, tokenId);
  }
  
  public ResultEntity<List> getRelationsMapByDirectoryIdForResources(Long directoryId, String platCode, String tokenId) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationsMapByDirectoryId(directoryId, DCConst.DataResourceCategory.RES, platCode, tokenId);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByPkEntityIdForResources(Long pkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationsByPkEntityId(pkEntityId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByPkEntityIdForForMetadata(Long pkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationsByPkEntityId(pkEntityId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<List<EntityChildRelationsItemVO>> getChildEntityRelationsByDirectoryIdForResources(Long directoryId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getChildEntityRelationsByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<List<EntityChildRelationsItemVO>> getChildEntityRelationsByDirectoryIdForMetadata(Long directoryId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getChildEntityRelationsByDirectoryId(directoryId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<Boolean> delEntityRelationGroupForResources(Long pkEntityId, Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).delEntityRelationGroup(pkEntityId, fkEntityId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<Boolean> delEntityRelationGroupForMetadata(Long pkEntityId, Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).delEntityRelationGroup(pkEntityId, fkEntityId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<Map> getRelationListByDirectoryIdForMetadata(GetRelationsDataDTO getRelationsDataDTO, String platCode) {
    getRelationsDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationListByDirectoryId(getRelationsDataDTO);
  }
  
  public ResultEntity<Map> getRelationListByDirectoryIdForResources(GetRelationsDataDTO getRelationsDataDTO, String platCode) {
    getRelationsDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationListByDirectoryId(getRelationsDataDTO);
  }
  
  public ResultEntity<Map> getRelationGroupListByDirectoryIdForResources(GetRelationsDataDTO getRelationsDataDTO, String platCode) {
    getRelationsDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationGroupListByDirectoryId(getRelationsDataDTO);
  }
  
  public ResultEntity<Map> getRelationGroupListByDirectoryIdFoMetadata(GetRelationsDataDTO getRelationsDataDTO, String platCode) {
    getRelationsDataDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getRelationGroupListByDirectoryId(getRelationsDataDTO);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByFkEntityIdForResources(Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationsByFkEntityId(fkEntityId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getEntityRelationsByFkEntityIdForData(Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationsByFkEntityId(fkEntityId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<Map> getEntityRelationGroupInfoForResources(Long pkEntityId, Long fkEntityId, String platCode, String tokenId) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationGroupInfo(pkEntityId, fkEntityId, DCConst.DataResourceCategory.RES, tokenId, platCode);
  }
  
  public ResultEntity<Map> getEntityRelationGroupInfoForData(Long pkEntityId, Long fkEntityId, String platCode, String tokenId) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).getEntityRelationGroupInfo(pkEntityId, fkEntityId, DCConst.DataResourceCategory.DATA, tokenId, platCode);
  }
  
  public ResultEntity<UseEntityRelationInfoVO> checkBeforeDelRelationForResources(Long pkEntityId, Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).checkBeforeDelRelation(pkEntityId, fkEntityId, tokenId, DCConst.DataResourceCategory.RES, platCode);
  }
  
  public ResultEntity<UseEntityRelationInfoVO> checkBeforeDelRelationForData(Long pkEntityId, Long fkEntityId, String tokenId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).checkBeforeDelRelation(pkEntityId, fkEntityId, tokenId, DCConst.DataResourceCategory.DATA, platCode);
  }
  
  public ResultEntity<Boolean> editEntityRelationsForResources(EditEntityRelationsDTO editEntityRelationsDTO, boolean isAdd, String platCode) {
    editEntityRelationsDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).editEntityRelations(editEntityRelationsDTO, true);
  }
  
  public ResultEntity<Boolean> editEntityRelationsForData(EditEntityRelationsDTO editEntityRelationsDTO, boolean isAdd, String platCode) {
    editEntityRelationsDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).editEntityRelations(editEntityRelationsDTO, true);
  }
  
  public ResultEntity<Boolean> updateEntityRelationsForResources(UpdateEntityRelationsDTO updateEntityRelationsDTO, String platCode) {
    updateEntityRelationsDTO.setDataResourceCategory(DCConst.DataResourceCategory.RES);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).updateEntityRelations(updateEntityRelationsDTO);
  }
  
  public ResultEntity<Boolean> updateEntityRelationsForData(UpdateEntityRelationsDTO updateEntityRelationsDTO, String platCode) {
    updateEntityRelationsDTO.setDataResourceCategory(DCConst.DataResourceCategory.DATA);
    return ((IEntityRelation)ServiceUtil.getEntityRelationManager(platCode, IEntityRelation.class)).updateEntityRelations(updateEntityRelationsDTO);
  }
  
  public ResultEntity<List<InfoItemVO>> getMetadataInfoItemsForData(EntityItemInfoSearchDTO entityItemInfoSearchDTO) {
    entityItemInfoSearchDTO.setIsResources(DCConst.DataResourceCategory.DATA);
    return ((IInfoItem)ServiceUtil.getInfoItemManager(entityItemInfoSearchDTO.getPlatCode(), IInfoItem.class)).getMetadataInfoItems(entityItemInfoSearchDTO);
  }
  
  public ResultEntity<List<InfoItemVO>> getMetadataInfoItemsForRes(EntityItemInfoSearchDTO entityItemInfoSearchDTO) {
    entityItemInfoSearchDTO.setIsResources(DCConst.DataResourceCategory.RES);
    return ((IInfoItem)ServiceUtil.getInfoItemManager(entityItemInfoSearchDTO.getPlatCode(), IInfoItem.class)).getMetadataInfoItems(entityItemInfoSearchDTO);
  }
  
  private List<MetaEntityRelationsVO> parseResToMetaEntityRelationsList(List<ResEntityRelationsPO> metaResEntityRelationsList, List<MetaEntityRelationsVO> metaEntityRelationsList) {
    if (!CollectionUtils.isEmpty(metaResEntityRelationsList))
      for (ResEntityRelationsPO resEntityRelationsPO : metaResEntityRelationsList) {
        MetaEntityRelationsVO metaEntityRelationsVO = new MetaEntityRelationsVO();
        BeanUtils.copyProperties(resEntityRelationsPO, metaEntityRelationsVO);
        metaEntityRelationsList.add(metaEntityRelationsVO);
      }  
    return metaEntityRelationsList;
  }
  
  private List<MetaEntityRelationsVO> parseDataToMetaEntityRelationsList(List<MetadataEntityRelationsPO> metadataEntityRelationsList, List<MetaEntityRelationsVO> metaEntityRelationsList) {
    if (!CollectionUtils.isEmpty(metadataEntityRelationsList))
      for (MetadataEntityRelationsPO metadataEntityRelationsPO : metadataEntityRelationsList) {
        MetaEntityRelationsVO metaEntityRelationsVO = new MetaEntityRelationsVO();
        BeanUtils.copyProperties(metadataEntityRelationsPO, metaEntityRelationsVO);
        metaEntityRelationsList.add(metaEntityRelationsVO);
      }  
    return metaEntityRelationsList;
  }
  
  public List<MetaEntityRelationsVO> getChildRelationsByEntityId(Long pkEntityId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResChildRelationsByEntityId(pkEntityId);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getChildRelationsByEntityId(pkEntityId);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public List<MetaEntityRelationsVO> getRelationsByEntityId(Map<String, Object> param, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationsByEntityId(param);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationsByEntityId(param);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public Integer getRelationsCountByEntityId(Long entityId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationsCountByEntityId(entityId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationsCountByEntityId(entityId);
  }
  
  public List<MetaEntityRelationsVO> getParentRelationsByEntityId(Long fkEntityId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResParentRelationsByEntityId(fkEntityId);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getParentRelationsByEntityId(fkEntityId);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public int addMetadataEntityRelations(MetaEntityRelationsDTO relation, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      ResEntityRelationsPO resEntityRelationsPO = new ResEntityRelationsPO();
      if (relation != null) {
        BeanUtils.copyProperties(relation, resEntityRelationsPO);
        return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).addResMetadataEntityRelations(resEntityRelationsPO);
      } 
    } else {
      MetadataEntityRelationsPO metadataEntityRelationsPO = new MetadataEntityRelationsPO();
      if (relation != null) {
        BeanUtils.copyProperties(relation, metadataEntityRelationsPO);
        return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).addMetadataEntityRelations(metadataEntityRelationsPO);
      } 
    } 
    return 0;
  }
  
  public MetaEntityRelationsVO getEntityRelationById(Long relationId, Integer dataResourceCategory, String platCode) {
    MetaEntityRelationsVO metaEntityRelationsVO = null;
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      ResEntityRelationsPO resEntityRelationsPO = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResEntityRelationById(relationId);
      if (resEntityRelationsPO != null) {
        metaEntityRelationsVO = new MetaEntityRelationsVO();
        BeanUtils.copyProperties(resEntityRelationsPO, metaEntityRelationsVO);
      } 
    } else {
      MetadataEntityRelationsPO metadataEntityRelationsPO = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getEntityRelationById(relationId);
      if (metadataEntityRelationsPO != null) {
        metaEntityRelationsVO = new MetaEntityRelationsVO();
        BeanUtils.copyProperties(metadataEntityRelationsPO, metaEntityRelationsVO);
      } 
    } 
    return metaEntityRelationsVO;
  }
  
  public int deleteMetadataEntityRelationsByRelationId(Long relationId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).deleteResMetadataEntityRelationsByRelationId(relationId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).deleteMetadataEntityRelationsByRelationId(relationId);
  }
  
  public int deleteMetadataEntityRelationsByIds(List<Long> ids, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).deleteResMetadataEntityRelationsByIds(ids); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).deleteMetadataEntityRelationsByIds(ids);
  }
  
  public int updateMetadataEntityRelations(MetaEntityRelationsDTO updateRelation, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      ResEntityRelationsPO resEntityRelationsPO = new ResEntityRelationsPO();
      BeanUtils.copyProperties(updateRelation, resEntityRelationsPO);
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).updateResMetadataEntityRelations(resEntityRelationsPO);
    } 
    MetadataEntityRelationsPO metadataEntityRelationsPO = new MetadataEntityRelationsPO();
    BeanUtils.copyProperties(updateRelation, metadataEntityRelationsPO);
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).updateMetadataEntityRelations(metadataEntityRelationsPO);
  }
  
  public List<MetaEntityRelationsVO> getRelationReferenceChain(Long entityId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationReferenceChain(entityId);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationReferenceChain(entityId);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public List<Map> getUseRelationInterfaceInfo(Long pkEntityId, Long fkEntityId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getUseResRelationInterfaceInfo(pkEntityId, fkEntityId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getUseRelationInterfaceInfo(pkEntityId, fkEntityId);
  }
  
  public List<Long> getAllRelationIdsByInfoItemId(Long infoItemId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getAllResRelationIdsByInfoItemId(infoItemId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getAllRelationIdsByInfoItemId(infoItemId);
  }
  
  public List<MetaEntityRelationsVO> getAllRelationsByPkAndFkEntityId(Long pkEntityId, Long fkEntityId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getAllResRelationsByPkAndFkEntityId(pkEntityId, fkEntityId);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getAllRelationsByPkAndFkEntityId(pkEntityId, fkEntityId);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public List<MetaEntityRelationsVO> getRelationsByFkEntityId(Long fkEntityId, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationsByFkEntityId(fkEntityId);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationsByFkEntityId(fkEntityId);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public int deleteRelationsByPkAndFkEntityId(Long pkEntityId, Long fkEntityId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).deleteResRelationsByPkAndFkEntityId(pkEntityId, fkEntityId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).deleteRelationsByPkAndFkEntityId(pkEntityId, fkEntityId);
  }
  
  public List<MetaEntityRelationsVO> getRelationGroupListByEntityId(Map<String, Object> param, Integer dataResourceCategory, String platCode) {
    List<MetaEntityRelationsVO> metaEntityRelationsList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory)) {
      List<ResEntityRelationsPO> metaResEntityRelationsList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationGroupListByEntityId(param);
      parseResToMetaEntityRelationsList(metaResEntityRelationsList, metaEntityRelationsList);
    } else {
      List<MetadataEntityRelationsPO> metadataEntityRelationsList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationGroupListByEntityId(param);
      parseDataToMetaEntityRelationsList(metadataEntityRelationsList, metaEntityRelationsList);
    } 
    return metaEntityRelationsList;
  }
  
  public int getRelationGroupCountByEntityId(Long entityId, Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getResRelationGroupCountByEntityId(entityId); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getRelationGroupCountByEntityId(entityId);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getChildRelationsByEntityIdForResources(Long pkEntityId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getDataResourceManager(platCode, IEntityRelation.class)).getChildRelationsByEntityId(pkEntityId, DCConst.DataResourceCategory.RES);
  }
  
  public ResultEntity<List<MetadataEntityRelationsVO>> getChildRelationsByEntityIdForForMetadata(Long pkEntityId, String platCode) {
    return ((IEntityRelation)ServiceUtil.getDataResourceManager(platCode, IEntityRelation.class)).getChildRelationsByEntityId(pkEntityId, DCConst.DataResourceCategory.DATA);
  }
  
  public List<Long> getChildTableEntityIds(Integer dataResourceCategory, String platCode) {
    if (DCConst.DataResourceCategory.RES.equals(dataResourceCategory))
      return ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).getChildTableEntityIds(); 
    return ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).getChildTableEntityIds();
  }
}
